<!doctype html>
<!--[if lt IE 7]> <html class="no-js ie6 oldie" lang="en"> <![endif]-->
<!--[if IE 7]>    <html class="no-js ie7 oldie" lang="en"> <![endif]-->
<!--[if IE 8]>    <html class="no-js ie8 oldie" lang="en"> <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en"> <!--<![endif]-->

<?php
/*
	Copyright 2018-2019 Bery Rinaldo

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License, version 2, as 
	published by the Free Software Foundation. A copy of the license is at
	http://www.gnu.org/licenses/gpl-2.0.html

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
*/
?>

<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link rel="shortcut icon" href="/images/favicon.ico"  type="image/x-icon" />
<link rel='stylesheet' id='highresponsive-fonts-css'  href='https://fonts.googleapis.com/css?family=Lato%3A300%2C400%2C700%2C900%2C300italic%2C400italic%2C700italic%2C900italic%7CPlayfair+Display%3A400%2C700%2C900%2C400italic%2C700italic%2C900italic%7CInconsolata%3A400&#038;subset=latin%2Clatin-ext' type='text/css' media='all' />

<style>
#sublogo { 
  margin:auto;
  padding:0;
}
#sublogo img{margin-left:auto; margin-right:auto; margin-top: 2px; margin-bottom: 2px; display:block; width:auto; max-height:80px;}

p {
    /* adjust here for paragraph margins -- start 0.4em; end 0.2em; */
    margin-block-start: 0;
    margin-block-end: 0;
}

.inday {
  min-height: 4em;
  font-family: 'Lato',Arial,Helvetica;
  font-size: 7pt;
  padding-top: 3px;
  padding-left: 3px;
  padding-bottom: 3px;
  /*line-height: 1.3em;*/
}
@media screen and (max-width:639px) {
  .inday {
    visibility:hidden;
    display:none;
  }
}

@media print {
  @page {
    size:letter landscape;
  }
  table {
    page-break-inside: avoid;
  }
}
</style>

<?php

global $org_key;
$org_key = "";
global $org_name;
$org_name = "";

include '../../../wp-load.php';
$org_key = get_option( 'serviceu_calendar_orgkey' );
$org_name = get_option( 'blogname' );

#if(isset($_GET) & !empty($_GET))
#{
#	//user posted variables
#	$org_key = $_GET['orgkey'];
#	$org_name = $_GET['orgname'];
#}

global $gOcc_id;
global $gEvent_id;
global $gOcc_start;
global $gOcc_end;
global $gEvent_name;
global $gEvent_desc;
global $bjrsu_Display_times;
global $gDept;
global $today_today;
global $master_array;

global $dept_param;
global $exclude_param;

# PHP will read to EOL with fgets...
$auto_detect_line_endings = TRUE;

global $debug;
$debug = 0;

if (isset($_GET['debug']) && ($_GET['debug'] !== '')) {
	$debug = $_GET['debug'];
}
global $week_start_day;
$week_start_day = 'Sunday';

# set our local timezone so no matter where the server is, this script runs on CA time...
date_default_timezone_set('America/Los_Angeles');

# Current time on the server
$current_time = time();
$local_displaytime = date ("m/d/Y H:i T",$current_time);

$today_today = date ("Ymd",$current_time);
$our_displaytime = date ("m/d/Y H:i",$current_time);

$dept_param = "";
$exclude_param = "";
$year_param = date("Y",$current_time);
$month_param = date("m",$current_time);
$print_param = 0;

if (isset($_GET['m']) && ($_GET['m'] !== '')) {
	$month_param = $_GET['m'];
}
if (isset($_GET['month']) && ($_GET['month'] !== '')) {
	$month_param = $_GET['month'];
}
if (isset($_GET['y']) && ($_GET['y'] !== '')) {
	$year_param = $_GET['y'];
}
if (isset($_GET['year']) && ($_GET['year'] !== '')) {
	$year_param = $_GET['year'];
}
if (isset($_GET['d']) && ($_GET['d'] !== '')) {
	$dept_param = $_GET['d'];
}
if (isset($_GET['department']) && ($_GET['department'] !== '')) {
	$dept_param = $_GET['department'];
}
if (isset($_GET['x']) && ($_GET['x'] !== '')) {
	$exclude_param = $_GET['x'];
print "<!-- DEBUG: excl $exclude_param -->\n";
}
if (isset($_GET['exclude']) && ($_GET['exclude'] !== '')) {
	$exclude_param = $_GET['exclude'];
print "<!-- DEBUG: excl $exclude_param -->\n";
}
if (isset($_GET['print']) && ($_GET['print'] !== '')) {
	$print_param = $_GET['print'];
}
if ($year_param < 2003) {
	$year_param = 2003;
}

$first_of_month = mktime(0,0,0,$month_param,1,$year_param);

$month = date("F",$first_of_month);
$year = date("Y",$first_of_month);
$display_month = "$month $year";

if ($debug) {
  echo "<!-- Server $local_displaytime -- $org_name $our_displaytime -->\n";
}

?>

<SCRIPT LANGUAGE="JavaScript">

<!-- Begin

function popwindow(url)
{
  day = new Date();
  id = day.getTime();
  eval("page" + id + " = window.open(url, '" + id + "', 'toolbar=0,scrollbars=1,location=0,statusbar=0,menubar=0,resizable=1,width=500,height=375');");
}

// End -->

</script>
<title><?php print "$display_month @ $org_name"; ?></title>
</head>

<?php

$last_year = $year_param;
$last_mon = $month_param - 1;
if ($last_mon < 1) {
  if ($last_year > 2003) {
    $last_mon = 12;
    $last_year = $last_year - 1;
  } else {
    # stop at Jan 2003
    $last_mon = 1;
  }
}

$cal_start_date = sprintf("%d-%02d-01",$year_param,$month_param);
$next_year = $year_param;
$next_mon = $month_param + 1;
if ($next_mon > 12) {
  $next_mon = 1;
  $next_year = $next_year + 1;
}
$cal_end_date = sprintf("%d-%02d-01",$next_year,$next_mon);

$random_num = rand();
$url = "https://api.serviceu.com/rest/events/occurrences?orgKey=$org_key&startDate=$cal_start_date&endDate=$cal_end_date";
if ($debug) {
  print "\n<p>debug URL $url <p>\n";
}
$gopt = stream_context_create (array("ssl" => array("ignore_errors" => true, "verify_peer" => false, "verify_peer_name" => false, "allow_self_signed" => true)));
$handle = @fopen($url, "r", false, $gopt);
$maint = 1;
if ($handle) {
  
  if ($debug) {
    print "\n<p>handle $handle <p>\n";
  }

  // Create an xml parser
  $xmlParser = xml_parser_create();

  // Set up element handler
  xml_set_element_handler( $xmlParser, "startElement", "endElement" );

  // Set up character handler
  xml_set_character_data_handler( $xmlParser, "charElement" );

  while (!feof ($handle)) {
    $buffer = fgets($handle);
    if ($debug) {
      print "\n<p>buffer $buffer <p>\n";
    }
    if ($buffer == "") {
      if ($debug) {
        print "\n<p>null buffer found<p>\n";
      }
    } else {
      $maint = 0;
      xml_parse( $xmlParser, $buffer, feof($handle) );
    }
  }

fclose ($handle);
}

# Begin the "real" calendar stuff....

$current_time = $first_of_month;

# Headings...

print "<body bgcolor=#ffffff><center>\n";

if ($maint) {
  print "<font size=\"6\" color=\"#ff2222\" face=\"'Lato',Arial,Helvetica\">Unable to contact calendar server.  Please try again later.</font><br>\n";
}

#if ($print_param) {
## print "<div style=\"width: 100%; text-align: center;\"><span style=\"font-family:'Lato',Arial,Heletica; font-size: 16pt; font-weight: 900; letter-spacing: 0.05em;\">$org_name</span><br><span style=\"font-family:'Lato',Arial,Heletica; font-size: 9pt; color: rgb(52, 52, 52);\">connections that matter</span></div><br>\n";
##
#} else {
#  print "<div id=\"sublogo\">\n";
#  print "<font size=\"6\" color=\"#000080\" face=\"'Lato',Arial,Helvetica\"><a href=\"/\"><img border=\"0\" src=\"/images/logo.gif\" alt=\"$org_name\"></a></font></div>\n";
#}

global $dept_param;
global $exclude_param;

$deptvar = "";
$depthead = "";
if ($dept_param != "") {
  $depthead = "<font size=4 color=#000080 face='Lato',Arial,Helvetica>$dept_param Calendar</font><p>\n";
  $deptvar .= "&d=".$dept_param;
}
if ($exclude_param != "") {
  $deptvar .= "&x=".$exclude_param;
}
  $mhead = "<div style=\"padding-bottom: 5px; width: 100%; text-align: center;\"><div style=\"display: inline-block;\"><span style=\"font-family:'Lato',Arial,Heletica; font-size: 16pt; font-weight: 900; letter-spacing: 0.05em;\">$org_name</span><br><span style=\"font-family:'Lato',Arial,Heletica; font-size: 9pt; color: rgb(52, 52, 52);\">connections that matter</span>$depthead</div>";

print "<table border=\"1\" cellpadding=\"1\" cellspacing=\"0\" width=\"90%\">\n";

$dpath = dirname(__FILE__);
$doc_root = $_SERVER["DOCUMENT_ROOT"];
# $ppath = preg_replace("|$doc_root|","",$dpath);
# if ($debug) { print "\n\n<p>DEBUG: $ppath $doc_root $dpath<p>\n"; }
$encorgname = urlencode ( $org_name );

if ($print_param) {
  print "<tr><td align=\"center\" colspan=\"7\"><span style=\"padding-left: 5px; color:#fff; float:left; font-family:'Lato',Arial,Heletica; font-size: 24pt;\">$display_month</span>$mhead<span style=\"padding-right: 5px; float:right; font-family:'Lato',Arial,Heletica; font-size: 24pt;\">$display_month</span></div></td></tr>\n";
} else {
  print "<tr><td align=\"center\" colspan=\"7\"><span style=\"padding-left: 5px; color:#fff; float:left; font-family:'Lato',Arial,Heletica; font-size: 24pt;\">$display_month</span>$mhead<span style=\"padding-right: 5px; float:right; font-family:'Lato',Arial,Heletica; font-size: 24pt;\">$display_month</span></div></td></tr>\n";
  #print "<tr><td align=\"center\" colspan=\"7\">$mhead<br><span style=\"font-family:'Lato',Arial,Heletica; font-size: 24pt;\">$display_month</span><span style=\"padding-left: 5px; color:#fff; float:left; font-family:'Lato',Arial,Heletica; font-size: 24pt;\"><a href=\"$ppath/month.php?m=$last_mon&y=$last_year$deptvar\">&lt;&lt;</a>&nbsp;</span><span style=\"padding-right: 5px; float:right; font-family:'Lato',Arial,Heletica; font-size: 24pt;\">&nbsp;<a href=\"$ppath/month.php?m=$next_mon&y=$next_year$deptvar\">&gt;&gt;</a></span></div></td></tr>\n";
}
print "<tr>\n";
print "<td style=\"font-family:'Lato',Arial,Heletica; font-size: 9pt; text-align:center;\" width=\"14%\">Sun</td>\n";
print "<td style=\"font-family:'Lato',Arial,Heletica; font-size: 9pt; text-align:center;\" width=\"14%\">Mon</td>\n";
print "<td style=\"font-family:'Lato',Arial,Heletica; font-size: 9pt; text-align:center;\" width=\"14%\">Tue</td>\n";
print "<td style=\"font-family:'Lato',Arial,Heletica; font-size: 9pt; text-align:center;\" width=\"14%\">Wed</td>\n";
print "<td style=\"font-family:'Lato',Arial,Heletica; font-size: 9pt; text-align:center;\" width=\"14%\">Thu</td>\n";
print "<td style=\"font-family:'Lato',Arial,Heletica; font-size: 9pt; text-align:center;\" width=\"14%\">Fri</td>\n";
print "<td style=\"font-family:'Lato',Arial,Heletica; font-size: 9pt; text-align:center;\" width=\"14%\">Sat</td>\n";
print "</tr>\n";

$year = date("Y",$current_time);
$day = date("j",$current_time);
$mon = date("n",$current_time);

// dateOfWeek() takes a date in Ymd and a day of week in 3 letters or more
// and returns the date of that day. (ie: "sun" or "sunday" would be acceptable values of $day but not "su")

function dateOfWeek($Ymd, $day)
{
  $week_start_day = 'Sunday';
  $timestamp = strtotime($Ymd);
  $num = date('w', strtotime($week_start_day));
  $start_day_time = strtotime((date('w',$timestamp)==$num ? "$week_start_day" : "last $week_start_day"), $timestamp);
  $ret_unixtime = strtotime($day,$start_day_time);
  $ret_unixtime = strtotime('+12 hours', $ret_unixtime);
  $ret = date('Ymd',$ret_unixtime);
  return $ret;
}

function startElement( $parser, $tagName, $attrs )
{
global $gOcc_id;
global $gEvent_id;
global $gOcc_start;
global $bjrsu_Display_times;
global $gOcc_end;
global $gEvent_name;
global $gEvent_desc;
global $gDept;

    global $debug, $gText, $gTitle, $gLink, $gDescription, $gPubDate;
    if ($debug) { print "<br>DEBUG: startElement $tagName $gText <br>\n"; }
    $gText = "";
    switch( $tagName ) {
      case 'OCCURRENCE':
        $gOcc_id = "";
        $gEvent_id = "";
        $gOcc_start = "";
        $gOcc_end = "";
        $gEvent_name = "";
	$bjrsu_Display_times = "";
if ($debug) { print "<br>DEBUG: C: Display_times $bjrsu_Display_times<br>\n"; }
        $gEvent_desc = "";
	$gDept = "";
        break;
    }
}

function endElement( $parser, $tagName )
{
global $gOcc_id;
global $gEvent_id;
global $gOcc_start;
global $gOcc_end;
global $gEvent_name;
global $gEvent_desc;
global $bjrsu_Display_times;
global $gDept;
global $today_today;
global $dept_param;
global $exclude_param;
global $master_array;
global $debug;

    global $debug, $gText, $gTitle, $gLink, $gDescription, $gPubDate;
    if ($debug) { print "<br>DEBUG: endElement $tagName $gText <br>\n"; }
    switch( $tagName ) {
      case 'OCCURRENCEID':
        $gOcc_id = $gText;
        break;
      case 'EVENTID':
        $gEvent_id = $gText;
        break;
      case 'DISPLAYTIMES':
	$bjrsu_Display_times = $gText;
if ($debug) { print "<br>DEBUG: B: Display_times $bjrsu_Display_times<br>\n"; }
	break;
      case 'OCCURRENCESTARTTIME':
        $gOcc_start = $gText;
        break;
      case 'OCCURRENCEENDTIME':
        $gOcc_end = $gText;
        break;
      case 'DEPARTMENTNAME':
        $gDept = $gText;
        break;
      case 'NAME':
        $gEvent_name = $gText;
        break;
      case 'DESCRIPTION':
        $gEvent_desc = preg_replace("/http:\/\/[^<>[:space:]]+[[:alnum:]\/]/",
                     "<a target=\"_blank\" href=\"\\0\">\\0</a>", $gText);
        break;
      case 'OCCURRENCE':
        if ($debug) { print "<b>DEBUG</b> End OCCURRENCE $gOcc_id $gEvent_id $gOcc_start $gOcc_end $gEvent_name $gEvent_desc<br>\n"; }


        preg_match ("/([0-9]{2})\/([0-9]{2})\/([0-9]{4}) ([0-9]{2}):([0-9]{2}):([0-9]{2}) ([AP]M)/", $gOcc_start, $regs);
        if ($regs[7] == 'PM' && $regs[4] < 12) { $regs[4] += 12; }
        if ($regs[7] == 'AM' && $regs[4] == 12) { $regs[4] = 0; }

        $start_unixtime = mktime($regs[4], $regs[5], $regs[6], $regs[1], $regs[2], $regs[3]);
        $start_date = date("l, F j, Y",$start_unixtime);
        $start_time = date("g:i A",$start_unixtime);
        $event_date = date ("Ymd",$start_unixtime);
if ($debug) { print "DEBUG $event_date $today_today<p>\n"; }

        if ($event_date == $today_today) {
	  $color = "bgcolor=\"#ddddff\"";
        } else {
	  $color = "";
        }
        preg_match ("/([0-9]{2})\/([0-9]{2})\/([0-9]{4}) ([0-9]{2}):([0-9]{2}):([0-9]{2}) ([AP]M)/", $gOcc_end, $regs);
        if ($regs[7] == 'PM' && $regs[4] < 12) { $regs[4] += 12; }
        if ($regs[7] == 'AM' && $regs[4] == 12) { $regs[4] = 0; }

        $end_unixtime = mktime($regs[4], $regs[5], $regs[6], $regs[1], $regs[2], $regs[3]);
        $end_time = date("g:i A",$end_unixtime);
        $event_end_date = date ("Ymd",$end_unixtime);

if ($debug) { print "DEBUG gDept $gDept dept_param $dept_param $exclude_param<br>\n"; }
	if ( strcmp($exclude_param,"") == 0 ||
	     strstr($gDept,$exclude_param) == FALSE) {
	  if ( strcmp($dept_param,"") == 0 ||
	       strstr($gDept,$dept_param) != FALSE) {
if ($debug) { print "DEBUG MASTER_ARRAY $event_date $gOcc_id $start_time $end_time $gEvent_name<p>\n"; }
	    $master_array[$event_date][$gOcc_id] = array( 'date' => $event_date, 'start' => $start_time, 'end' => $end_time, 'name' => $gEvent_name, 'id' => $gOcc_id, 'displaytimes' => $bjrsu_Display_times );
          }
        }
        break;
    }
}

function charElement( $parser, $text )
{
global $master_array;
global $gOcc_id;
global $gEvent_id;
global $gOcc_start;
global $gOcc_end;
global $gEvent_name;
global $gEvent_desc;
global $gDept;
global $bjrsu_Display_times;

  global $debug, $gText, $gTitle, $gLink, $gDescription, $gPubDate;
  if ($debug) { print "<br>DEBUG: charElement $text $gText <br>\n"; }
  $gText .= trim( $text );
}


$minical_month = date("m", $current_time);
$minical_year = date("Y", $current_time);
$first_of_month = $minical_year.$minical_month."01";
$start_day = strtotime(dateOfWeek($first_of_month, $week_start_day));
$i = 0;
$whole_month = TRUE;
do {
  $day = date ("j", $start_day);
  $daylink = date ("Ymd", $start_day);
  $check_month = date ("m", $start_day);
  if ($i == 0) echo "<tr>\n";
  if ($today_today == $daylink && !$print_param) {
    echo "<td bgcolor=\"#ddddff\" valign=\"top\" align=\"left\">\n";
  } else {
    echo "<td valign=\"top\" align=\"left\">\n";
  }
  if ($check_month != $minical_month) {
    echo "<div class=\"inday\">\n";
    echo "&nbsp;\n";
  } else {
   
    #echo "<font face=\"'Lato',Arial,Helvetica\" size=\"2\">$day</font>\n";
    echo "<span style=\"margin-top: 2px; margin-right: 5px; float:right; font-family:'Lato',Arial,Heletica; font-size: 14pt;\">$day</span>\n";
    echo "<div class=\"inday\">\n";
    if ($print_param) {
      echo "";
    } else {
      echo "<p>\n";
    }
    #echo "<font face=\"'Lato',Arial,Helvetica\" size=\"1\">\n";

if ($debug) { print "<br>DEBUG: daylink $daylink<br>\n"; }
    if (isset($master_array[$daylink])) {
if ($debug) { print "<br>DEBUG: Got some $daylink<br>\n"; }
      foreach ($master_array[$daylink] as $val) {
        $ostart = $val['start'];
	$ostart = preg_replace("/ PM/","pm",$ostart);
	$ostart = preg_replace("/ AM/","am",$ostart);
        $oend = $val['end'];
	$oend = preg_replace("/ PM/","pm",$oend);
	$oend = preg_replace("/ AM/","am",$oend);
        $oname = $val['name'];
        $oid = $val['id'];
	$dt = $val['displaytimes'];

if ($debug) { print "<br>DEBUG: A: Display_times $dt<br>\n"; }
	if ($dt == "false")
	{
		if ($print_param)
		{
			echo "$oname<br>\n";
		}
		else
		{
			echo "<a href=\"javascript:popwindow('?eventid=$oid')\">$oname</a><p>\n";
		}
	}
	else
	{
		if ($ostart == "12:00am")
		{
			if ($oend == "11:59pm")
			{
				if ($print_param)
				{
					echo "* $oname<br>\n";
				}
				else
				{
					echo "* <a href=\"javascript:popwindow('?eventid=$oid')\">$oname</a><p>\n";
				}
			}
			else
			{
				$oend = preg_replace("/ /","&nbsp;",$oend);
				$display_times = "(ends&nbsp;$oend)";
				if ($print_param)
				{
					echo "* $oname $display_times<br>\n";
				}
				else
				{
					echo "* <a href=\"javascript:popwindow('?eventid=$oid')\">$oname</a> $display_times<p>\n";
				}
			}
		}
		else
		{
			$star = "";
			if ($oend == "11:59pm")
			{
				$star = " *";
			}
			if ($print_param) {
				echo "$ostart $oname$star<br>\n";
			}
			else
			{
				echo "$ostart <a href=\"javascript:popwindow('?eventid=$oid')\">$oname</a>$star<p>\n";
			}
		}
	}

      }
    }
    if (!$print_param) {
      echo " <p>\n";
    }
  }
  echo "</div></td>\n";
  $start_day = ($start_day + (24.5 * 60 * 60));
  $i++;
  if ($i == 7) { 
    echo "</tr>\n";
    $i = 0;
    $checkagain = date ("m", $start_day);
    if ($checkagain != $minical_month) $whole_month = FALSE;	
  }
} while ($whole_month == TRUE);

?>

</table>
<?php
if (!$print_param) {
  print "<table border=0 width=98%>\n";
  print "<tr><td width=33%><font face='Lato',Arial,Helvetica size=2>Calendar generated at: $our_displaytime</font></td>";
  if ($dept_param || $exclude_param) {
    print "<td width=34% align=center><font face='Lato',Arial,Helvetica size=2><a href=\"?month=$month_param&year=$year_param\">Complete Calendar</a></font></td>";
  } else {
    print "<td width=34%>&nbsp;</td>";
  }
  print "<td width=33% align=right><font face='Lato',Arial,Helvetica size=2><a href=\"/\">$org_name</a>&nbsp;&nbsp;&nbsp;&nbsp; <a href=\"?month=$last_mon&year=$last_year$deptvar\">Previous Month</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <a href=\"?month=$next_mon&year=$next_year$deptvar\">Next Month</a>&nbsp;&nbsp;&nbsp;&nbsp; <a href=\"?month=$month_param&year=$year_param$deptvar&print=1\">Print Version</a></font></td></tr>\n";
  print "</table>\n";
}
?>
</center>
</body>
</html>
